using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Polymod
{
    internal class ParentModelInfo : IParentModelInfo
    {
        private IModel _parent;
        private string _memberName;

        /// <summary>
        /// Gets Parent
        /// </summary>
        public IModel Parent
        {
            get { return _parent; }
        }

        /// <summary>
        /// Gets MemberName
        /// </summary>
        public string MemberName
        {
            get { return _memberName; }
        }

        public ParentModelInfo(IModel parent, string memberName)
        {
            if (memberName == null) throw new System.ArgumentNullException("memberName");
            if (parent == null) throw new System.ArgumentNullException("parent");
            _parent = parent;
            _memberName = memberName;
        }
    }
}
